#pragma once

//////////////////
// GLOBAL ENUMS
enum DCMOTOR_ERRORS {
	DCMOTOR_NO_ERRORS,
	DCMOTOR_INVALID_HANDLE,
	DCMOTOR_DCB_RETRIEVAL,
	DCMOTOR_DCB_CREATION,
	DCMOTOR_SET_COMM_STATE,
	DCMOTOR_SET_TIMEOUTS,
	DCMOTOR_COM_WRITE,
	DCMOTOR_NOT_ALL_WRITTEN,
	DCMOTOR_HANDLE_NOT_CLOSED,
	DCMOTOR_QUEUE_FULL
};

typedef struct DCMotorCommand {
	bool bForward; // true if forward
	unsigned int nSpeed; // 
} DCMotorCommand;

class CDCMotor : public CStatic
{
	DECLARE_DYNAMIC(CDCMotor)

public:
	CDCMotor(void);
	~CDCMotor(void);
	int Open(CString csPort);
	int Close(void);
	CString GetLastError(void);
	int IssueCommand(bool bForward, unsigned int nSpeed);

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnMessageError(WPARAM errnum, LPARAM l); // Message handler for errors that occur in the worker thread
	afx_msg LRESULT OnMessageThreadFinished(WPARAM w, LPARAM l); // Message handler for notifying the class that the worker thread has finished

protected:
	bool m_bOpen;
	bool m_bComsEstablished;
	HANDLE m_hComThread;
	CString m_csLastError;

};
