int value = 0;                          
int PIN_PWM = 9;                       
int PIN_DIR = 8;

void ProcessPacket(boolean forward, unsigned int motorSpeed);

void setup() 
{ 
  pinMode(PIN_DIR, OUTPUT);
  pinMode(PIN_PWM, OUTPUT);
  Serial.begin(9600);
} 
 
void loop() 
{ 
  // Get packet
  if (Serial.available() >= 7){
    if (Serial.read() == 0x02){ 
      // Got an STX
      // Read in the direction
      boolean forward = false;
      if (Serial.read() == 1) forward = true;
      
      // Read in steps - 4 bytes (forming an unsigned int)
      unsigned int motorSpeed = Serial.read();
      motorSpeed = (Serial.read()<<8) + motorSpeed;
      motorSpeed = (Serial.read()<<16) + motorSpeed;
      motorSpeed = (Serial.read()<<24) + motorSpeed;
      
      // Now check to see if a valid packet was received
      if (Serial.read() == 0x03){
        ProcessPacket(forward, motorSpeed);
      }
    }
  } 
} 

void ProcessPacket(boolean forward, unsigned int motorSpeed){
  if (forward) digitalWrite(PIN_DIR, LOW);
  else digitalWrite(PIN_DIR, HIGH);

  analogWrite(PIN_PWM, motorSpeed);
}  
